unit hiImg_CurveBezier;

interface

uses Windows,Kol,Share,Img_Draw;

{$I share.inc}

type
  ThiImg_CurveBezier= class(THIDraw2PA)
   private
   public
     _prop_Offset: integer;
     _data_Offset: THI_Event;

     procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation

procedure ThiImg_CurveBezier._work_doDraw;
var dt: TData;
    pen: HPEN;
    mPen: PGeometricPen;
    mTransform: PTransform;
    PointsArray: array[0..3] of TPoint;
begin
    dt := _Data;
TRY
    if not ImgGetDC(_Data) then exit;
    ReadXY(_Data);
    ImgNewSizeDC;
   
    PointsArray[0] := MakePoint(x1, y1); //start position
    PointsArray[3] := MakePoint(x2, y2); //finish position 
    PointsArray[1] := MakePoint(x3, y3); //first curve
    PointsArray[2] := MakePoint(x4, y4); //second curve  
{ --------------      () -------------- }
    mPen := ReadObject(_Data, _data_Pen, GEOMETRICPEN_GUID);
    if mPen <> nil then mPen._Set(pDC, x1, y1, FScale) //  ,    
     else
      begin //  "" 
       pen := CreatePen(ord(_prop_LineStyle), Round((fScale.x + fScale.y) * ReadInteger(_Data,_data_Size,_prop_Size)/2), Color2RGB(ReadInteger(_Data,_data_Color,_prop_Color)));
       SelectObject(pDC,Pen);
      end;
{ --------------------------   ------------------------- }
    mTransform := ReadObject(_Data, _data_Transform, TRANSFORM_GUID);
    if mTransform <> nil then
     if mTransform._Set(pDC,x1,y1,x2,y2) then //    (rotate, flip)
      begin
       PRect(@x1)^ := mTransform._GetRect(MakeRect(x1,y1,x2,y2));
       PRect(@x3)^ := mTransform._GetRect(MakeRect(x3,y3,x4,y4));
      end;
    PolyBezier(pDC, PointsArray, 4); //draw line
    if mTransform <> nil then mTransform._Reset(pDC); //  
    if mPen <> nil then mPen._Delete(pDC) else DeleteObject(Pen); //      
FINALLY
    ImgReleaseDC;
    _hi_CreateEvent(_Data,@_event_onDraw,dt);
END;
end;

end.