unit hiImg_Pen;

interface

uses Windows,Kol,Share,Img_Draw;

{$I share.inc}

type
  THIImg_Pen = class(THIImg)
   private
    mPen: PGeometricPen;
    pen: HPEN;
    prevMit: Single;
    prevPt: TPoint;
    arrStyle: array of cardinal;
    strStyle: string;
    
    procedure SetUserStyle;
    procedure _Set(PenDC:HDC;PenX,PenY:integer;PenScale:TScale);
    procedure _Delete(PenDC:HDC);
   public
    _prop_EndCap: byte;
    _prop_LineJoin: byte;
    _prop_MiterLimit: single;
    _prop_InsideFrame: boolean;
    _prop_SizingUserStyle: boolean;
    _prop_Style: byte;

    _data_Offset:THI_Event;
   
    destructor Destroy; override;
    property _prop_UserStyle: string write strStyle;
    procedure _var_Pen(var _Data:TData; Index:word);
    procedure _work_doEndCap(var _Data: TData; Index: Word);
    procedure _work_doLineJoin(var _Data: TData; Index: Word);
    procedure _work_doMiterLimit(var _Data: TData; Index: Word);
    procedure _work_doInsideFrame(var _Data: TData; Index: Word);
    procedure _work_doUserStyle(var _Data: TData; Index: Word);
    procedure _work_doStyle(var _Data:TData; Index:word);
    procedure _work_doTransparent(var _Data: TData; Index: Word);
    procedure _work_doSize(var _Data: TData; Index: Word);
  end;

implementation

destructor THIImg_Pen.Destroy;
begin
   DeleteObject(Pen);
   inherited;
end;  

procedure THIImg_Pen._Delete;
begin
   if _prop_MiterLimit <> 10 then SetMiterLimit(PenDC, prevMit, 0);
   SetBrushOrgEx(PenDC, prevPt.X, prevPt.Y, nil);
   DeleteObject(Pen);
end;

procedure THIImg_Pen._Set;
var Pattern: PBitmap;
    logBrush: TLogBrush;
    p, pStyle: cardinal;
    _data: TData; // del

    function GetPattern:boolean;
    begin
      Pattern := ReadBitmap(_Data,_data_Pattern);
      if Assigned(Pattern) and not Pattern.Empty then Result := True
       else Result := False;
    end;

begin
   pStyle := PS_GEOMETRIC;
   case _prop_EndCap of
    0: pStyle := pStyle or PS_ENDCAP_FLAT;
    1: pStyle := pStyle or PS_ENDCAP_ROUND;
    2: pStyle := pStyle or PS_ENDCAP_SQUARE;
   end; 
   case _prop_LineJoin of
    0: pStyle := pStyle or PS_JOIN_BEVEL;
    1: pStyle := pStyle or PS_JOIN_ROUND;
    2: begin
        pStyle := pStyle or PS_JOIN_MITER;
        SetMiterLimit(PenDC, _prop_MiterLimit, @prevMit);
       end;
   end; 
{ -------------------      ----------------------- }
   if _prop_PatternStyle and GetPattern then
    begin
     logBrush.lbStyle := BS_PATTERN;
     logBrush.lbHatch := Pattern.Handle;
    end
   else
    begin
     logBrush.lbColor := Color2RGB(ReadInteger(_Data,_data_Color,_prop_Color)); 
     if _prop_Style = 0 then logBrush.lbStyle := BS_SOLID 
     else
      begin
       logBrush.lbStyle := BS_HATCHED;
       logBrush.lbHatch := _prop_Style - 1;
       if _prop_Transparent then SetBkMode(PenDC, TRANSPARENT)
       else
        begin
         SetBkMode(PenDC, OPAQUE);
         SetBkColor(PenDC, Color2RGB(ReadInteger(_Data,_data_bgColor,_prop_bgColor)));
        end;
      end;
    end;
{ ------------------------------   -------------------------------- }
   case _prop_UseOffsetFill of
    1: SetBrushOrgEx(PenDC, x1, y1, @prevPt);
    2: begin
        p := cardinal(ReadInteger(_Data, _data_OffsetFill, 0));
        SetBrushOrgEx(PenDC, smallint(p and $FFFF), smallint(p shr 16), @prevPt);
       end;
   end; 
   if Length(arrStyle) > 0 then pStyle := pStyle or PS_USERSTYLE;
   if _prop_InsideFrame    then pStyle := pStyle or PS_INSIDEFRAME;
   Pen := ExtCreatePen(pStyle, Round((penScale.x + penScale.y) * _prop_Size / 2), logBrush, Length(arrStyle), arrStyle);
   SelectObject(PenDC, Pen);
end;

procedure THIImg_Pen._var_Pen;
begin
    if mPen = nil then mPen := CreateGeometricPen(_Set, _Delete);
    dtObject(_Data, GEOMETRICPEN_GUID, mPen);
end;

procedure THIImg_Pen._work_doSize;
begin
    _prop_Size := ToInteger(_Data);
    SetUserStyle;
end;

procedure THIImg_Pen._work_doEndCap;
begin
    _prop_EndCap := ToInteger(_Data);
    SetUserStyle;
end;

procedure THIImg_Pen._work_doLineJoin;
begin
    _prop_LineJoin := ToInteger(_Data);
    SetUserStyle;
end;

procedure THIImg_Pen._work_doMiterLimit;
begin
    _prop_MiterLimit := ToReal(_Data);
end;

procedure THIImg_Pen._work_doInsideFrame;
begin
    _prop_InsideFrame := ReadBool(_Data);
end;

procedure THIImg_Pen._work_doStyle;
begin
    _prop_Style := ToInteger(_Data);
end;

procedure  THIImg_Pen._work_doUserStyle;
begin
    strStyle := ToString(_data);
    SetUserStyle;
end;

procedure THIImg_Pen._work_doTransparent;
begin
    _prop_Transparent := ReadBool(_Data);
end;

procedure  THIImg_Pen.SetUserStyle;
var w, p, i, ind: integer;
    s: string;
begin
    ind := 0;
    s := strStyle;
    SetLength(arrStyle, ind);
    if s = '' then exit;
    if _prop_SizingUserStyle then w := _prop_Size
     else w := 1;
    while s <> '' do
    begin
     p := Pos(',', s);
     if p > 0 then
      begin
       i := str2int(Copy(s, 1, p-1));
       Delete(s, 1, p);
      end
     else
      begin
       i := str2int(s);
       s := '';
      end; 
     SetLength(arrStyle, ind + 1);
     i := i * w;
     case _prop_EndCap of
      1,2: if odd(ind) then inc(i,w) else dec(i,w);
     end;
     arrStyle[ind] := i;
     inc(ind);
    end;
end;

end.